

REM uses the class library TctecUSB4.dll

REM Version 1.1 updated 17-April-2008
REM version 1.2 updates 27-April-2008



Public Class Form1

    REM update the relay module based on the combo box and bitmask settings

    Private Sub setRelays()

        Dim relayBoard As String

        Try
            relayBoard = ComboBox1.SelectedItem.ToString()
        Catch ex As Exception
            Return
        End Try

        If (relayBoard.Length <= 0) Then Return

        REM turn unselected bits off
        TctecUSB4.TctecUSB4.setBits(relayBoard, (NumericUpDown1.Value Xor 15), False)
        REM turn selected bits on
        TctecUSB4.TctecUSB4.setBits(relayBoard, NumericUpDown1.Value, CheckBox_RelayOn.Checked)

    End Sub

    REM flag to prevent recursive update of BitMask and Checkboxes
    Dim dontupdatecheckBoxes As Boolean = False


    REM checkbox changes cause the bitmask field to update
    REM then the relays are set
    Private Sub updateBitMask()

        If (dontupdatecheckBoxes) Then Return

        Dim BitMask As Integer = 0

        If CheckBox_b3.Checked Then BitMask = BitMask Or 8
        If CheckBox_b2.Checked Then BitMask = BitMask Or 4
        If CheckBox_b1.Checked Then BitMask = BitMask Or 2
        If CheckBox_b0.Checked Then BitMask = BitMask Or 1

        NumericUpDown1.Value = BitMask


    End Sub


    Private Sub ComboBox1_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBox1.SelectedIndexChanged





    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        TctecUSB4.TctecUSB4.listTCTECRelays()

        ComboBox1.Items.Clear()

        ComboBox1.Items.AddRange(TctecUSB4.TctecUSB4.getSerialNumbers().ToArray())
        If ComboBox1.Items.Count > 0 Then
            ComboBox1.SelectedIndex = 0
        End If



    End Sub

    Private Sub NumericUpDown1_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDown1.ValueChanged


        REM the bitmask value has been changed
        REM so update the check boxes if necessary
        
        Dim checkboxState As Integer = 0
        If (CheckBox_b0.Checked) Then checkboxState = checkboxState Or 1
        If (CheckBox_b1.Checked) Then checkboxState = checkboxState Or 2
        If (CheckBox_b2.Checked) Then checkboxState = checkboxState Or 4
        If (CheckBox_b3.Checked) Then checkboxState = checkboxState Or 8

        REM is the bitmask the same as the check boxes ?

        Dim bitMask As Integer = NumericUpDown1.Value

        If (bitMask <> checkboxState) Then

            REM the value was changed but not the checkboxes, update the checkboxes
            dontupdatecheckBoxes = True REM prevent the checkbox update event from calling this function

            If ((bitMask And 1) > 0) Then CheckBox_b0.Checked = True Else CheckBox_b0.Checked = False
            If ((bitMask And 2) > 0) Then CheckBox_b1.Checked = True Else CheckBox_b1.Checked = False
            If ((bitMask And 4) > 0) Then CheckBox_b2.Checked = True Else CheckBox_b2.Checked = False
            If ((bitMask And 8) > 0) Then CheckBox_b3.Checked = True Else CheckBox_b3.Checked = False

            dontupdatecheckBoxes = False

        End If





        







        setRelays()
    End Sub

    Private Sub CheckBox_b1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox_b2.CheckedChanged
        updateBitMask()
    End Sub

    Private Sub CheckBox_b2_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox_b1.CheckedChanged, CheckBox_b2.CheckedChanged
        updateBitMask()
    End Sub

    Private Sub CheckBox_b0_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox_b0.CheckedChanged
        updateBitMask()
    End Sub

    Private Sub CheckBox_RelayOn_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox_RelayOn.CheckedChanged
        setRelays()
    End Sub

    Private Sub CheckBox_b3_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox_b3.CheckedChanged
        updateBitMask()
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

    End Sub
End Class
